
#ifndef _TYPE_H_
#define _TYPE_H_


/***************************************************
 * attribute for mcu ( types, ... ) 
 ***************************************************/

//#include <stdbool.h>
#include "ch32f20x.h"
typedef unsigned char bool;

#ifndef MIN
#define MIN(a,b) ((a) > (b) ? (b) : (a))
#endif

#ifndef MAX
#define MAX(a,b) ((a) < (b) ? (b) : (a))
#endif

#ifndef ABS
#define ABS(a)  ((a) < 0 ? (-(a)) : (a))
#endif


#ifndef NULL
#define NULL        ((void *) 0)
#endif

//typedef enum { false, true } bool;

#ifndef _SIZE_T
#define _SIZE_T
typedef unsigned int size_t;
#endif

#ifndef FALSE 
#define FALSE 0	
#endif

#ifndef TRUE
#define TRUE 1
#endif


#define HIGH    1
#define LOW     0

typedef char int8;
typedef volatile char vint8;
typedef unsigned char uint8;
typedef unsigned char u8;
typedef volatile unsigned char vuint8;
typedef int int16;
//typedef int s16;
typedef unsigned short uint16;
typedef unsigned short u16;
typedef long int32;
//typedef long s32;
typedef unsigned long uint32;

//typedef unsigned long u32;

 
typedef void                    func(void*);


#endif /* _TYPE_H_ */
