
#ifndef SM_TIMER_H
#define SM_TIMER_H

#include "types.h"

#define SMTIMER_LOOPS_FOREVER 0xFFFF

typedef struct {
    u32 runtime;
    u16 ms;   // set timers time
    u16 run_loops; // 0xFFFF is forever
    func *pfn;
    void *arg;
}smtimer_elem_t;

#define SM_TIMER_NUM 20


void smtimer_tick_cnt(u32 ms);
void smtimer_init(void);
void smtimer_proc(void);
u8 smtimer_set_timer(u16 ms,func *pfn,void *arg,u16 loops);
#endif

